commit:     d16b97d50adcc81c90a0035365310594e7b19a1f
Author:     Joonas Niilola <juippis <AT> gentoo <DOT> org>
AuthorDate: Tue Jan 31 10:30:57 2023 +0000
Commit:     Joonas Niilola <juippis <AT> gentoo <DOT> org>
CommitDate: Tue Jan 31 10:30:57 2023 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=d16b97d5

app-containers/lxd: re-add 4.0.9 to the tree

 - it's needed, and it's only purpose is to provide an update path
   from lxd-3 to lxd-5. lxd-3 is supported until June 2023.

Signed-off-by: Joonas Niilola <juippis <AT> gentoo.org>

 app-containers/lxd/Manifest                        |   2 +
 .../lxd/files/lxd-4.0.9-glibc-2.36-fix.patch       |  74 +++++++++
 app-containers/lxd/lxd-4.0.9-r3.ebuild             | 181 +++++++++++++++++++++
 3 files changed, 257 insertions(+)

diff --git a/app-containers/lxd/Manifest b/app-containers/lxd/Manifest
index 8c94a3ceb31e..fd079b683160 100644
--- a/app-containers/lxd/Manifest
+++ b/app-containers/lxd/Manifest
@@ -1,3 +1,5 @@
+DIST lxd-4.0.9.tar.gz 9117078 BLAKE2B 
aa6689c1e958258484fba5c060765dd71d5406cb4375d3132cdc38633277e6c95322e8e3aed5e9dd251140c6868ec42470e797639dde4af42848e138f3b45ee2
 SHA512 
657949311753895f3941deaabae2d03092fc67490d2de78db48b296fdd3e9df4c5844467dd6913814426ca423a6ee1da9705bb1a2652ea99fe1356eb7da97ebb
+DIST lxd-4.0.9.tar.gz.asc 833 BLAKE2B 
7cd0d3ab518d947ca3ea6dc804c6a59b592e4e568152c078fdd3c102420bcd94d2f0b2c335b8b4ecdb19dc3c9a10f665a1510903f395247da956717beaa172a3
 SHA512 
79a4111571ab43e79cf669e416ed50f3ccae0fbceb86d73757d23c778035e827f47643bc87ff6a2fc64b095345a3d53cbd0c4eb245c75364e907d7449f3a0886
 DIST lxd-5.0.1.tar.gz 14640923 BLAKE2B 
81bdf3301c0eecc719864cd8e18fd886113f83d1980e13ee4d4ccb6641ee4a7e33f0b859a21abd8a0a9956d1c2f3dfa6e7eb1ae454fbb580c23b5558ef51168e
 SHA512 
b04b7329bdeb17ca384cc2d931a1510d5f03521fd247eab93904bbcb6139cc0daf28f9aeb6416268ccf15affdd15b26598f3e280fb5eefe5c59be6918f092bed
 DIST lxd-5.0.1.tar.gz.asc 833 BLAKE2B 
d233c8ebfb5b71f66ff08b4d74861a42bf45ef3e9622d4f113603a7a6c1a29b5aa3422c075ad5250a7d5ab7526a49dd676672d0a73194024af477fa762e02b12
 SHA512 
bf22f26b6688420e843e9e24eb731a2068eae3d90c77787e0f4a279d4cb7a8a2df38b7e9c8ea79f604c1d54743238cb36474baf018ea6bf72e6f37838b252294
 DIST lxd-5.0.2-move-shellcheck-version-call-into-static-analysis.patch 882 
BLAKE2B 
4c4cb8b19709939c0c14ed87e5d9c917ac967471400de07c14ea049c0a8aae9a2ed0e3755d554cb1077ee7c607fcdc71431d57a55becd0a46c1f177bc9b33aed
 SHA512 
266788186ca9aabda4ad0fe5fa47ef3acfa31bee64c742c011c58a39f4da833f768e8bb71ec81b57af8d4f124d733f2c22ab33f9ee1bc4ecbd21f5bbbae1f6e7

diff --git a/app-containers/lxd/files/lxd-4.0.9-glibc-2.36-fix.patch 
b/app-containers/lxd/files/lxd-4.0.9-glibc-2.36-fix.patch
new file mode 100644
index 000000000000..d05ff2c81bd9
--- /dev/null
+++ b/app-containers/lxd/files/lxd-4.0.9-glibc-2.36-fix.patch
@@ -0,0 +1,74 @@
+From cc7bab602e6b967fdd31c5feed0f3f6321c0a0a7 Mon Sep 17 00:00:00 2001
+From: Luca Barbato <[email protected]>
+Date: Fri, 13 Jan 2023 21:43:22 +0000
+Subject: [PATCH] Fix syscall wrappers
+
+---
+ lxd/include/syscall_wrappers.h | 7 ++++---
+ lxd/main_nsexec.go             | 2 +-
+ shared/idmap/shift_linux.go    | 2 +-
+ 3 files changed, 6 insertions(+), 5 deletions(-)
+
+diff --git a/lxd/include/syscall_wrappers.h b/lxd/include/syscall_wrappers.h
+index 2c28133a8..a6975ab4d 100644
+--- a/lxd/include/syscall_wrappers.h
++++ b/lxd/include/syscall_wrappers.h
+@@ -26,10 +26,10 @@ static inline int lxd_close_range(unsigned int fd, 
unsigned int max_fd, unsigned
+       return syscall(__NR_close_range, fd, max_fd, flags);
+ }
+ 
+-static inline int open_tree(int dfd, const char *filename, unsigned int flags)
++/* static inline int open_tree(int dfd, const char *filename, unsigned int 
flags)
+ {
+       return syscall(__NR_open_tree, dfd, filename, flags);
+-}
++}*/
+ 
+ /*
+  * mount_setattr()
+@@ -40,7 +40,7 @@ struct lxc_mount_attr {
+       __u64 propagation;
+       __u64 userns_fd;
+ };
+-
++/*
+ static inline int mount_setattr(int dfd, const char *path, unsigned int flags,
+                               struct lxc_mount_attr *attr, size_t size)
+ {
+@@ -53,6 +53,7 @@ static inline int move_mount(int from_dfd, const char 
*from_pathname, int to_dfd
+       return syscall(__NR_move_mount, from_dfd, from_pathname, to_dfd,
+                      to_pathname, flags);
+ }
++*/
+ 
+ /* arg1 of prctl() */
+ #ifndef PR_SCHED_CORE
+diff --git a/lxd/main_nsexec.go b/lxd/main_nsexec.go
+index f11c0d4cb..753024283 100644
+--- a/lxd/main_nsexec.go
++++ b/lxd/main_nsexec.go
+@@ -298,7 +298,7 @@ static char *file_to_buf(char *path, ssize_t *length)
+ int mount_detach_idmap(const char *path, int fd_userns)
+ {
+       __do_close int fd_tree = -EBADF;
+-      struct lxc_mount_attr attr = {
++      struct mount_attr attr = {
+           .attr_set           = MOUNT_ATTR_IDMAP,
+ 
+       };
+diff --git a/shared/idmap/shift_linux.go b/shared/idmap/shift_linux.go
+index daaf37275..e219ac01c 100644
+--- a/shared/idmap/shift_linux.go
++++ b/shared/idmap/shift_linux.go
+@@ -314,7 +314,7 @@ static int get_userns_fd(void)
+ static int create_detached_idmapped_mount(const char *path)
+ {
+       __do_close int fd_tree = -EBADF, fd_userns = -EBADF;
+-      struct lxc_mount_attr attr = {
++      struct mount_attr attr = {
+           .attr_set           = MOUNT_ATTR_IDMAP,
+           .propagation        = MS_SLAVE,
+ 
+-- 
+2.39.0
+

diff --git a/app-containers/lxd/lxd-4.0.9-r3.ebuild 
b/app-containers/lxd/lxd-4.0.9-r3.ebuild
new file mode 100644
index 000000000000..f8d5b8f837b9
--- /dev/null
+++ b/app-containers/lxd/lxd-4.0.9-r3.ebuild
@@ -0,0 +1,181 @@
+# Copyright 1999-2023 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+inherit bash-completion-r1 go-module linux-info optfeature systemd verify-sig
+
+DESCRIPTION="Fast, dense and secure container management"
+HOMEPAGE="https://linuxcontainers.org/lxd/introduction/ 
https://github.com/lxc/lxd";
+SRC_URI="https://linuxcontainers.org/downloads/lxd/${P}.tar.gz
+       verify-sig? ( https://linuxcontainers.org/downloads/lxd/${P}.tar.gz.asc 
)"
+
+LICENSE="Apache-2.0"
+SLOT="0"
+KEYWORDS="~amd64 ~arm64 ~x86"
+IUSE="apparmor ipv6 nls verify-sig"
+
+DEPEND="acct-group/lxd
+       app-arch/xz-utils
+       >=app-containers/lxc-3.0.0[apparmor?,seccomp(+)]
+       dev-db/sqlite:3
+       dev-libs/dqlite
+       dev-libs/lzo
+       dev-libs/raft[lz4]
+       >=dev-util/xdelta-3.0[lzma(+)]
+       net-dns/dnsmasq[dhcp,ipv6(+)?]
+       sys-libs/libcap
+       virtual/udev"
+RDEPEND="${DEPEND}
+       net-firewall/ebtables
+       net-firewall/iptables[ipv6(+)?]
+       sys-apps/iproute2[ipv6(+)?]
+       sys-fs/fuse:*
+       sys-fs/lxcfs
+       sys-fs/squashfs-tools[lzma]
+       virtual/acl"
+BDEPEND="dev-lang/go
+       nls? ( sys-devel/gettext )
+       verify-sig? ( sec-keys/openpgp-keys-linuxcontainers )"
+
+CONFIG_CHECK="
+       ~CGROUPS
+       ~IPC_NS
+       ~NET_NS
+       ~PID_NS
+
+       ~SECCOMP
+       ~USER_NS
+       ~UTS_NS
+
+       ~KVM
+       ~MACVTAP
+       ~VHOST_VSOCK
+"
+
+ERROR_IPC_NS="CONFIG_IPC_NS is required."
+ERROR_NET_NS="CONFIG_NET_NS is required."
+ERROR_PID_NS="CONFIG_PID_NS is required."
+ERROR_SECCOMP="CONFIG_SECCOMP is required."
+ERROR_UTS_NS="CONFIG_UTS_NS is required."
+
+WARNING_KVM="CONFIG_KVM and CONFIG_KVM_AMD/-INTEL is required for virtual 
machines."
+WARNING_MACVTAP="CONFIG_MACVTAP is required for virtual machines."
+WARNING_VHOST_VSOCK="CONFIG_VHOST_VSOCK is required for virtual machines."
+
+# Go magic.
+QA_PREBUILT="/usr/bin/fuidshift
+       /usr/bin/lxc
+       /usr/bin/lxc-to-lxd
+       /usr/bin/lxd-agent
+       /usr/bin/lxd-benchmark
+       /usr/bin/lxd-p2c
+       /usr/sbin/lxd"
+
+VERIFY_SIG_OPENPGP_KEY_PATH=${BROOT}/usr/share/openpgp-keys/linuxcontainers.asc
+
+# The testsuite must be run as root.
+# make: *** [Makefile:156: check] Error 1
+RESTRICT="test"
+
+GOPATH="${S}/_dist"
+
+PATCHES=( "${FILESDIR}"/lxd-4.0.9-glibc-2.36-fix.patch )
+
+src_prepare() {
+       export GOPATH="${S}/_dist"
+
+       default
+
+       sed -i \
+               -e "s:\./configure:./configure --prefix=/usr 
--libdir=${EPREFIX}/usr/lib/lxd:g" \
+               -e "s:make:make ${MAKEOPTS}:g" \
+               Makefile || die
+
+       # Fix hardcoded ovmf file path, see bug 763180
+       sed -i \
+               -e "s:/usr/share/OVMF:/usr/share/edk2-ovmf:g" \
+               -e "s:OVMF_VARS.ms.fd:OVMF_VARS.secboot.fd:g" \
+               doc/environment.md \
+               lxd/apparmor/instance.go \
+               lxd/apparmor/instance_qemu.go \
+               lxd/instance/drivers/driver_qemu.go || die "Failed to fix 
hardcoded ovmf paths."
+
+       # Fix hardcoded virtfs-proxy-helper file path, see bug 798924
+       sed -i \
+               -e 
"s:/usr/lib/qemu/virtfs-proxy-helper:/usr/libexec/virtfs-proxy-helper:g" \
+               lxd/device/device_utils_disk.go || die "Failed to fix 
virtfs-proxy-helper path."
+
+       cp "${FILESDIR}"/lxd-4.0.9-r1.service "${T}"/lxd.service || die
+       if use apparmor; then
+               sed -i \
+                       '/^EnvironmentFile=.*/a 
ExecStartPre=\/usr\/libexec\/lxc\/lxc-apparmor-load' \
+                       "${T}"/lxd.service || die
+       fi
+
+       # Disable -Werror's from go modules.
+       find "${S}" -name "cgo.go" -exec sed -i "s/ -Werror / /g" {} + || die
+}
+
+src_configure() { :; }
+
+src_compile() {
+       export GOPATH="${S}/_dist"
+       export CGO_LDFLAGS_ALLOW="-Wl,-z,now"
+
+       for k in fuidshift lxd-benchmark lxc lxc-to-lxd; do
+               go install -v -x "${S}/${k}" || die "failed compiling ${k}"
+       done
+
+       go install -v -x -tags libsqlite3 "${S}"/lxd || die "Failed to build 
the daemon"
+
+       # Needs to be built statically
+       CGO_ENABLED=0 go install -v -tags netgo "${S}"/lxd-p2c
+       CGO_ENABLED=0 go install -v -tags agent,netgo "${S}"/lxd-agent
+
+       use nls && emake build-mo
+}
+
+src_test() {
+       emake check
+}
+
+src_install() {
+       export GOPATH="${S}/_dist"
+       local bindir="_dist/bin"
+
+       dosbin ${bindir}/lxd
+
+       for l in fuidshift lxd-agent lxd-benchmark lxd-p2c lxc lxc-to-lxd; do
+               dobin ${bindir}/${l}
+       done
+
+       newbashcomp scripts/bash/lxd-client lxc
+
+       newconfd "${FILESDIR}"/lxd-4.0.0.confd lxd
+       newinitd "${FILESDIR}"/lxd-4.0.9.initd lxd
+
+       systemd_dounit "${T}"/lxd.service
+       systemd_newunit "${FILESDIR}"/lxd-containers-4.0.0.service 
lxd-containers.service
+       systemd_newunit "${FILESDIR}"/lxd-4.0.0.socket lxd.socket
+
+       dodoc AUTHORS doc/*
+       use nls && domo po/*.mo
+}
+
+pkg_postinst() {
+       elog
+       elog "Consult https://wiki.gentoo.org/wiki/LXD for more information,"
+       elog "including a Quick Start."
+       elog "For virtual machine support, see:"
+       elog "https://wiki.gentoo.org/wiki/LXD#Virtual_machines";
+       elog
+       elog "Please run 'lxc-checkconfig' to see all optional kernel features."
+       elog
+       optfeature "virtual machine support" 
app-emulation/qemu[spice,usbredir,virtfs]
+       optfeature "btrfs storage backend" sys-fs/btrfs-progs
+       optfeature "lvm2 storage backend" sys-fs/lvm2
+       optfeature "zfs storage backend" sys-fs/zfs
+       elog
+       elog "Be sure to add your local user to the lxd group."
+}

Reply via email to